# -*- coding: utf-8 -*-
#
# Copyright (c) 2018, HILSTER GmbH, Germany - https://hilster.de
# All rights reserved.
#

from __future__ import absolute_import, division, print_function

from .core import __version_info__, __version__

from .core import ByteType, BitType, ByteStruct, BitStruct, EncodeException, DecodeException, \
    ChecksumMismatchException, RegularExpressionMismatchException, OserNode
from ._varint import UBVarInt, ULVarInt, SBVarInt, SLVarInt


from ._typedef import BDouble, BFloat, BitField, Flag, LDouble, LFloat, Nibble, SBInt16, SBInt32, SBInt64, SBInt8, \
    SLInt16, SLInt32, SLInt64, SLInt8, UBInt16, UBInt32, UBInt64, UBInt8, ULInt16, ULInt32, ULInt64, ULInt8

from ._constant import Constant

from ._array_type import Array
from ._enum import Enum
from ._if_ import If
from ._if_else import IfElse
from ._fuzzing import RandomIntegerFuzzingValue, RandomFloatFuzzingValue, \
    RandomBitsFuzzingValue, RandomStringFuzzingValue, RandomBytesFuzzingValue
from ._null import Null
from ._padding_flag import PaddingFlag
from ._padding import Padding
from .nothing import Nothing
from ._string import String
from ._data import Data
from ._switch import Switch
from ._value import Value
from ._lazy_initialization import Lazy
from ._repeat_until import RepeatUntil

from ._json_adapter import JSONAdapter
from ._protocol_buffers_adapter import ProtocolBuffersAdapter
from ._regular_expression_match import RegularExpressionMatch

from ._crc import CRCL8, CRCB8, CRCL16, CRCB16, CRCL32, CRCB32, CRCL64, CRCB64

from ._util import to_hex

__all__ = [
    "__version_info__", "__version__",
    "OserNode",
    "ByteType", "BitType", "ByteStruct", "BitStruct", "EncodeException", "DecodeException", "ChecksumMismatchException",
    "RegularExpressionMismatchException",
    "UBVarInt", "ULVarInt", "SBVarInt", "SLVarInt",
    "BDouble", "BFloat", "BitField", "Flag", "LDouble", "LFloat", "Nibble", "SBInt16", "SBInt32", "SBInt64", "SBInt8",
    "SLInt16", "SLInt32", "SLInt64", "SLInt8", "UBInt16", "UBInt32", "UBInt64", "UBInt8", "ULInt16", "ULInt32",
    "ULInt64", "ULInt8",
    "Constant",
    "Array",
    "Enum",
    "If",
    "IfElse",
    "RandomIntegerFuzzingValue", "RandomFloatFuzzingValue", "RandomBitsFuzzingValue", "RandomStringFuzzingValue",
    "RandomBytesFuzzingValue",
    "Null",
    "PaddingFlag",
    "Padding",
    "Nothing",
    "String",
    "Data",
    "Switch",
    "Value",
    "Lazy",
    "JSONAdapter",
    "ProtocolBuffersAdapter",
    "RegularExpressionMatch",
    "RepeatUntil",
    "CRCL8", "CRCB8", "CRCL16", "CRCB16", "CRCL32", "CRCB32", "CRCL64", "CRCB64",
    "to_hex",
]
