# -*- coding: utf-8 -*-
#
# Copyright (c) 2018, HILSTER GmbH, Germany - https://hilster.de
# All rights reserved.
#
# This file was generated by wrappergenerator.py
#

from __future__ import absolute_import, division, print_function, unicode_literals

from oser._lazy_initialization import Lazy as _Lazy


class Lazy(_Lazy):
    """
    ``Lazy`` can be used to realize lazy-initialization automatically.

    `cls` is instantiated on first access but not in :func:`__init__`.
    So if no access is done it will never be instantiated and will not occupy any memory and cpu time.
    """

    def __init__(self, cls, *args, **kwargs):
        """
        Args:
            cls: the class to be instantiated.
            *args: a tuple for positional arguments for ``cls``.
            **kwargs: a dict for named arguments for ``cls``.
        """
        super(Lazy, self).__init__(cls, *args, **kwargs)

