# -*- coding: utf-8 -*-
#
# Copyright (c) 2018, HILSTER GmbH, Germany - https://hilster.de
# All rights reserved.
#
# This file was generated by wrappergenerator.py
#

from __future__ import absolute_import, division, print_function, unicode_literals

from oser._null import Null as _Null


class Null(_Null):
    """
    A null-object that does not contain any data.
    """

    def __init__(self):
        """
        Args:
            value: the initial value.
        """
        super(Null, self).__init__()

    def byte_size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(Null, self).byte_size()

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded (always 0).

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(Null, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string. This is always an empty string.

        Args:
            full_data (bytes): the binary data string until the part to be
                encoded. The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            bytes: the encoded binary string.
        """
        return super(Null, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(Null, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.
        """
        return super(Null, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(Null, self).root()

    def set(self, value):
        """
        Set the value. Always raises an Exception.

        Args:
            value: the new value
        """
        return super(Null, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(Null, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(Null, self).size()

    def up(self):
        """
        Return the parent element.
        """
        return super(Null, self).up()

