# -*- coding: utf-8 -*-
#
# Copyright (c) 2018, HILSTER GmbH, Germany - https://hilster.de
# All rights reserved.
#
# This file was generated by wrappergenerator.py
#

from __future__ import absolute_import, division, print_function, unicode_literals

from oser._padding import Padding as _Padding


class Padding(_Padding):
    """
    Unsigned 8-Bit integer to fill data with a pattern.
    """

    def __init__(self, value=b'\x00', strict=False):
        """
        Args:
            value=b"\x00" (bytes or int): the value to be used as the pattern.
            strict: if set to True input data is compared to `value`. In case of a mismatch a `ValueError` is raised.
        """
        super(Padding, self).__init__(value=value, strict=strict)

    def byte_size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(Padding, self).byte_size()

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(Padding, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be encoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.
        """
        return super(Padding, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(Padding, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.
        """
        return super(Padding, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(Padding, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(Padding, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(Padding, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(Padding, self).size()

    def up(self):
        """
        Return the parent element.
        """
        return super(Padding, self).up()
