# -*- coding: utf-8 -*-
#
# Copyright (c) 2018, HILSTER GmbH, Germany - https://hilster.de
# All rights reserved.
#
# This file was generated by wrappergenerator.py
#

from __future__ import absolute_import, division, print_function, unicode_literals

from oser._value import Value as _Value


class Value(_Value):
    """
    ``Value`` evaluates a value for introspection. It does not appear in the encoded data.
    """

    def __init__(self, value):
        """
        Args:
            value (callable): a method or a lambda to generate the value.
        """
        super(Value, self).__init__(value=value)

    def byte_size(self):
        """
        The size is always 0 because ``Value`` does not appear in
        the encoded data.
        """
        return super(Value, self).byte_size()

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be decoded.
                The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(Value, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be
                encoded. The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            bytes: the encoded binary string.
        """
        return super(Value, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(Value, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.
        """
        return super(Value, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(Value, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(Value, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(Value, self).set_fuzzing_values(values=values)

    def size(self):
        """
        The size is always 0 because ``Value`` does not appear in
        the encoded data.
        """
        return super(Value, self).size()

    def up(self):
        """
        Return the parent element.
        """
        return super(Value, self).up()
