# -*- coding: utf-8 -*-
#
# Copyright (c) 2018, HILSTER GmbH, Germany - https://hilster.de
# All rights reserved.
#
# This file was generated by wrappergenerator.py
#

from __future__ import absolute_import, division, print_function, unicode_literals

from oser._varint import SBVarInt as _SBVarInt
from oser._varint import SLVarInt as _SLVarInt
from oser._varint import UBVarInt as _UBVarInt
from oser._varint import ULVarInt as _ULVarInt


class SBVarInt(_SBVarInt):
    """
    Signed, big endian variable length integer.
    """

    def __init__(self, value=0):
        """
        Args:
            value=0 (int): the initial value.
        """
        super(SBVarInt, self).__init__(value=value)

    def byte_size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(SBVarInt, self).byte_size()

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be
                decoded. The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(SBVarInt, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be
                encoded. The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            bytes: the encoded binary string.
        """
        return super(SBVarInt, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(SBVarInt, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.
        """
        return super(SBVarInt, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(SBVarInt, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(SBVarInt, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(SBVarInt, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(SBVarInt, self).size()

    def up(self):
        """
        Return the parent element.
        """
        return super(SBVarInt, self).up()


class SLVarInt(_SLVarInt):
    """
    Signed, little endian variable length integer.
    """

    def __init__(self, value=0):
        """
        Args:
            value=0 (int): the initial value.
        """
        super(SLVarInt, self).__init__(value=value)

    def byte_size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(SLVarInt, self).byte_size()

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be
                decoded. The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(SLVarInt, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be
                encoded. The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            bytes: the encoded binary string.
        """
        return super(SLVarInt, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(SLVarInt, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.
        """
        return super(SLVarInt, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(SLVarInt, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(SLVarInt, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(SLVarInt, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(SLVarInt, self).size()

    def up(self):
        """
        Return the parent element.
        """
        return super(SLVarInt, self).up()


class UBVarInt(_UBVarInt):
    """
    Unsigned, big endian variable length integer.
    """

    def __init__(self, value=0):
        """
        Args:
            value=0 (int): the initial value.
        """
        super(UBVarInt, self).__init__(value=value)

    def byte_size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(UBVarInt, self).byte_size()

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be
                decoded. The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(UBVarInt, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be
                encoded. The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            bytes: the encoded binary string.
        """
        return super(UBVarInt, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(UBVarInt, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.
        """
        return super(UBVarInt, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(UBVarInt, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(UBVarInt, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(UBVarInt, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(UBVarInt, self).size()

    def up(self):
        """
        Return the parent element.
        """
        return super(UBVarInt, self).up()


class ULVarInt(_ULVarInt):
    """
    Unsigned, little endian variable length integer.
    """

    def __init__(self, value=0):
        """
        Args:
            value=0 (int): the initial value.
        """
        super(ULVarInt, self).__init__(value=value)

    def byte_size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(ULVarInt, self).byte_size()

    def decode(self, data, full_data=b'', context_data=b''):
        """
        Decode a binary string and return the number
        of bytes that were decoded.

        Args:
            data (bytes): the data buffer that is decoded.
            full_data (bytes): the binary data string until the part to be
                decoded. The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            int: the number of bytes that were decoded.
        """
        return super(ULVarInt, self).decode(data=data, full_data=full_data, context_data=context_data)

    def encode(self, full_data=b'', context_data=b''):
        """
        Return the encoded binary string.

        Args:
            full_data (bytes): the binary data string until the part to be
                encoded. The user normally does not need to supply this.
            context_data (bytes): the binary data of the current context.
                The user normally does not need to supply this.

        Returns:
            bytes: the encoded binary string.
        """
        return super(ULVarInt, self).encode(full_data=full_data, context_data=context_data)

    def get(self):
        """
        Return the value.

        Returns:
            the value.
        """
        return super(ULVarInt, self).get()

    def introspect(self, stop_at=None):
        """
        Return the introspection representation of the object
        as a string.
        """
        return super(ULVarInt, self).introspect(stop_at=stop_at)

    def root(self):
        """
        return root element
        """
        return super(ULVarInt, self).root()

    def set(self, value):
        """
        Set the value.

        Args:
            value: the new value
        """
        return super(ULVarInt, self).set(value=value)

    def set_fuzzing_values(self, values):
        """
        Set fuzzing values.

        Args:
            values (iterable): the values used for fuzzing.
        """
        return super(ULVarInt, self).set_fuzzing_values(values=values)

    def size(self):
        """
        Return the length of the byte type in bytes.

        Returns:
            int: the length of the byte type in bytes.
        """
        return super(ULVarInt, self).size()

    def up(self):
        """
        Return the parent element.
        """
        return super(ULVarInt, self).up()
